* config.s       test setting system configuration
*                Pat Warnshuis  1-503-246-3724
*                April 1, 1986


start   bsr     gosuper              set supervisor mode
        bsr     _kinit
        dc.w    $a00a                hide mouse
        bsr     _clrscrn
        bsr     _crsron

        andi.b    #$fe,$ffff8240      white on black mono
        move.w  #$2,$4a6              # floppies
        move.b  #3,$4c5               only 2 drives active, use a #7 if you
*                                     have a hard disk is installed


        move.w #%000100,-(sp)         set printer
        move.w #33,-(sp)
        trap #14
        addq.l #4,sp

        move.w #-1,-(sp)              set rs232
        move.w #-1,-(sp)
        move.w #-1,-(sp)
        move.w #-1,-(sp)
        move.w #1,-(sp)
        move.w #7,-(sp)               1200 baud
        move.w #15,-(sp)
        trap #14
        add.l #14,sp

        bsr     _stime
        bsr     _sdate

        bsr     _crsroff
        dc.w    $a009                 show mouse
        bsr     gouser               exit supervisor mode to user mode
        bra     pterm                 return to gem


*******************************************************
*  config.lib  68K asm routines to support config.s
*              Pat Warnshuis (1-503-246-3724)
*              April 1, 1986
*
*


_kinit  clr.w   head
        clr.w   tail
        rts

******  long int ckkbd(); if(conis) kbuff[tail++]=conin()
*                         else fall thru to _ckbuf
*       if(conis)
*          conin();
*          if( tail++ == 64 ) tail = 0;
*          if( tail <> head ) kbuff[tail] = ch
*              else dump ch and fall thru to _ckbuf

_ckkbd  movem.l d1/a0,-(sp)    protect a0 in case we are filling a buffer
        bsr     conis          key active?
        beq.s   ckbuf1           no...ck kbuff
        bsr     necin            yes..get ch from keyboard
        move.w  tail,d1
        addq    #4,d1              tail++
        cmpi.w  #$100,d1             wrap tail?
        bne     ckkbd1                 no
        moveq   #0,d1                  yes..tail=0
ckkbd1  move.w  d1,tail              save new tail
        cmp.w   head,d1            caught up with head?
        beq.s   ckbuf2               yes...dump ch & get_kbuff[++h]
        lea     kbuff,a0             no....move key to buff
        move.l  d0,0(a0,d1.w)              kbuff[++t]=ch
        bra.s   ckbuf1         go ck buff

******  long int ckbuf(); if(kbuff[head]) ch=kbuff[head++], else ch=(-1)
*       if( head <> tail)
*          ch = kbuff[++h];
*          if( head == 80) head=0
*       else char = -1;
*

_ckbuf  movem.l d1/a0,-(sp)
ckbuf1  move.w  head,d1
        cmp.w   tail,d1        head==tail (empty)
        beq.s   ckbuf4           yes..return -1
ckbuf2  addq    #4,d1          head++
        cmpi.w  #$100,d1         wrap head?
        bne.s   ckbuf3             no
        moveq   #0,d1              yes..head=0
ckbuf3  move.w  d1,head        save head
        lea     kbuff,a0       ch=kbuff[++h]
        move.l  0(a0,d1.w),d0
        bra.s   ckbuf0
ckbuf4  moveq   #-1,d0         buff empty and no kbd
ckbuf0  movem.l (sp)+,d1/a0
        rts


******  char cget(); get kbuff[h] or wait for kbdin
*                    echo ch to screen

_cget   bsr     _ckkbd
        bmi.s   _cget
        bsr     conout         echo input
        rts
******  char cgetne(); same as cget() with no echo
*

_cgetne bsr     _ckkbd
        bmi.s   _cget
        rts


******  sput(s) char *s;       print string with no auto crlf
*                              display control characters
*                              send crlf for '\n'

_sput   move.l  4(sp),a0
sput    move.l  a0,-(sp)
sput1   move.b  (a0)+,d0
        beq.s   sput0
        cmpi.b  #$0a,d0        '\n' ?
        bne.s   sput2               no
        bsr     _crlf                yes
        bra.s   sput1
sput2   bsr     bconout
        bra.s   sput1
sput0   move.l  (sp)+,a0
        rts

******  integer *sget(prompt, response) char *prompt, response;
*               returns char cnt or -(spec char), if entered
*
*       sget    gets a string from console with edit functions
*               displays prompt (a0), and default response (a1)
*               immediate <return> returns default str & cnt=0
*               immediate ESC  restarts string
*                   to enter <esc> at start, enter it twice
*               immediate BS edits existing response string
*               any other char starts new response string
*               BS  at any char backspaces until 1st char
*               response is terminated by <return>
*               normal return is char cnt in d0
*                             a0 points to response (internal use)
*               any control char returns -(control char)
*               any spec key returns -(scan code)

****   integer  *sgetl(prompt, response, length)
*               same as sget() with max string length included

_sgetl  move.w  12(sp),d2      max string length
        bra.s   sgeta


_sget   move.w  #80,d2
sgeta   move.l  4(sp),a0       caller's prompt   string
        move.l  8(sp),a1       caller's response string
*                              internal call with a0=prompt, a1=response
sget
        move.l  a1,-(sp)       save -> start of response
        moveq   #$0,d1         strlen=0
        bsr     _eeol
        bsr     sput           display prompt
        bsr     _savcrsr
        tst.b   (a1)           default str?
        beq.s   sget3            no...start input
        move.l  (sp),a0          yes..display default
        bsr     sput
        bsr     slen                  get len of default response
        move.w  d0,d1
        add.w   d1,a1                 ptr to default end

sget1   bsr     _cgetne        1st char
        cmpi.b  #$0d,d0        CR?
        bne.s   sget1a
        moveq   #$0,d1           yes...rtn default str & cnt=0
        bra     sget9
sget1a  cmpi.b  #$08,d0        BS?
        beq.s   sget6            yes...do not erase str
        tst.w   d1               no ...erase str
        beq.s   sget2                  no str to erase
        move.w  d0,-(sp)               save 1st char
        bsr     _rescrsr               erase default response
        bsr     _eeol
        bsr     _savcrsr
        moveq   #0,d1                  reset cnt
        move.w  (sp)+,d0               retrieve char
        move.l  (sp),a1                ptr to default start

sget2
        cmpi.b  #$08,d0        BS?
        beq.s   sget6             yes...backup ptr
        cmpi.b  #$0d,d0        CR?
        beq.s   sget9             yes...wrap it up
        cmp.b   d1,d2          max cnt?
        beq.s   sget8             yes...ring de bell & ignore it
        tst.w   d0             special keys help, undo, function, etc?
        beq.s   sget4             yes...return -(scan code)
        bsr     bconout        echo char
        addq.b  #1,d1          bump char cnt
        move.b  d0,(a1)+       add char to str
sget3   bsr     _cgetne        get next char
        bra.s   sget2             and process it
      
sget4   swap    d0             special char..get scan code to d0.w
        cmp.b   #'G',d0        CLR/HOME?
        bne.s   sget5            no...return -(scancode)
        bsr     _rescrsr         yes..start over
        bsr     _eeol
        bsr     _savcrsr
        moveq   #0,d1
        move.l  (sp),a1
        bra.s   sget1
sget5   move.l  (sp),a1        return reply[0]  = scancode
        move.b  d0,(a1)+
        clr.b   (a1)
        neg.w   d0                    and count = -(scancode)
        bra.s   sget0
sget6   tst.b   d1             BS..at start?
        beq.s   sget1              yes..ignore it
        subq.b  #1,d1              no...adjust cnt
        clr.b   -(a1)                   delete last char
        bsr     bkspc                   backup cursor
        bra.s   sget3                   go get next
sget8   move.w  #$07,d0        Overflow!
        bsr     conout             sound bell
        bra.s   sget3              ignore char

sget9   clr.b   (a1)           terminate string
        move.w  d1,d0          done.  cnt -> d0
sget0   move.l  (sp)+,a0       return a0 ->  start of response string
        rts                           d0.w = char cnt or -(spec char)

******* integer slen(s) char *s;
_slen   move.l  4(sp),a0
slen    move.l  a0,-(sp)        stash ptr
        moveq   #-1,d0          char cnt
slen1   addq    #1,d0
        tst.b   (a0)+
        bne.s   slen1
slen0   move.l  (sp)+,a0        restore ptr
        rts

******  void gtime(str) char *str; string to receive time
*       enter time from key and convert to ascii in a0

_gtime  move.l  4(sp),a0       caller's string pointer
        bra.s   gtime1

*       use this entry for internal calls (use strbuff)
gtime   lea     strbuff,a0

gtime1  move.l  a0,-(sp)       park *str
        move.w  #23,-(sp)      gettime in d0.l
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,a0       retrieve *str

        andi.l  #$ffff,d0
        move.w  d0,-(sp)       temp storage
        lsr.w   #8,d0          hr
        lsr.w   #3,d0
        andi.w  #$1f,d0
        bsr.s   set2
        move.b  #':',(a0)+
        move.w  (sp),d0        min
        lsr.w   #5,d0
        andi.w  #$3f,d0
        bsr.s   set2
        move.b  #':',(a0)+
        move.w  (sp)+,d0       sec
        andi.w  #$1f,d0
        lsl.w   #1,d0
        bsr.s   set2
        clr.b   (a0)
        rts

******  Convert bin byte in d0 to ascii dec (0-99) in *a0
*       Support gtime and gdate routines
set2
        andi.l  #$ff,d0         clear hi word for divu
        divu    #10,d0          10's digit d0.lo, 1's digit d0.hi
        addi.l  #$300030,d0     convert bcd to ascii
        move.b  d0,(a0)+
        swap    d0
        move.b  d0,(a0)+
        rts

******  void gdate(s) char *s;  string to receive date
*       enter date from key & convert to ascii in caller's string

_gdate  move.l  4(sp),a0
        bra.s   gdate1

*       use this entry for internal calls (use strbuff)
gdate   lea     strbuff,a0

gdate1  move.l  a0,-(sp)
        move.w  #23,-(sp)       get date/time in d0.l
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,a0
        swap    d0              move date to d0.w
        andi.l  #$ffff,d0
        move.w  d0,-(sp)        store the packed dates (ha,ha,ha!)
        lsr.w   #5,d0           mo
        andi.w  #$0f,d0
        bsr.s   set2
        move.b  #'/',(a0)+
        move.w  (sp),d0         day
        andi.w  #$1f,d0
        bsr.s   set2
        move.b  #'/',(a0)+
        move.w  (sp)+,d0        yr
        lsr.w   #8,d0
        lsr.w   #1,d0
        add.b   #80,d0
        andi.w  #$7f,d0
        bsr.s   set2
        clr.b   (a0)
        rts 

******  VOID stime()
*       get time from keyboard and set system clock
_stime
        lea     strbuff,a0
        bsr     gtime          get time to ascii str in strbuff
        lea     strbuff,a1        display default time
        lea     timecue,a0        prompt
        move.w  #8,d2
        bsr     sget            get new time
        bsr     decbin          pack ascii time at a0 into d0.w
        lsl.w   #8,d0           decbin: 2 ascii digits at a0 -> bin in d0.w
        lsl.w   #3,d0           pack hr
        move.w  d0,-(sp)
        bsr     decbin          pack min
        lsl.w   #5,d0
        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)
        bsr     decbin          pack sec
        lsr.w   #1,d0   

        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)        park new time
        move.w  #23,-(sp)       get current date/time
        trap    #14
        addq.l  #2,sp
        move.w  (sp)+,d0        pack date/time
        move.l  d0,-(sp)        set hardware clock, xbios
        move.w  #22,-(sp)
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,d0        set sw clock, bios
        andi.l  #$ffff,d0
        move.w  d0,-(sp)
        move.w  #$2d,-(sp)
        trap    #1
        addq.l  #4,sp
        rts     


******* VOID set_date()
*       get date from keyboard and set system date
_sdate
        lea     strbuff,a0
        bsr     gdate           get date to ascii str in strbuff
        lea     strbuff,a1      default response
        lea     datecue,a0      prompt
        move.w  #10,d2
        bsr     sget            get new time in strbuff, *a0


        bsr     decbin          2 ascii at *a0 to binary in d0.w
        lsl.w   #5,d0           pack mo
        move.w  d0,-(sp)
        bsr     decbin          pack day
        move.w  (sp),d1
        or.w    d1,d0
        move.w  d0,(sp)
        bsr     decbin          pack yr
        cmpi.w  #1900,d0             2-digit or 4-digit?
        bmi.s   sdate1
        subi.w  #1900,d0
sdate1  subi.w #80,d0                less 80 for TOS format
        lsl.w   #8,d0
        lsl.w   #1,d0   
        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)        park new date
        move.w  #23,-(sp)       get current date/time
        trap    #14
        addq.l  #2,sp
        swap    d0              current time to d0.hi
        move.w  (sp)+,d0        new date to d0.lo
        swap    d0              pack date/time in d0.l
        move.l  d0,-(sp)        set hardware date/time, xbios
        move.w  #22,-(sp)
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,d0        set sw date, bios
        swap    d0
        andi.l  #$ffff,d0
        move.w  d0,-(sp)
        move.w  #$2b,-(sp)
        trap    #1
        addq.l  #4,sp
        rts     


**************************************************
*                                                *
*       VT52 functions                           *
*                                                *
**************************************************


_crlf   move.w  #$0d0a,d0
        bra     con2
_crlf2  bsr     _crlf
        bra     _crlf

_clrscrn move.w  #$1b45,d0
        bra     con2
_crsron move.w  #$1b65,d0
        bra     con2
_crsroff move.w  #$1b66,d0
        bra     con2
_savcrsr move.w  #$1b6a,d0
        bra     con2
_rescrsr move.w  #$1b6b,d0
        bra     con2
_eeol   move.w  #$1b4b,d0
        bra     con2

*********************************************************
**                                                     **
**                                                     **
**      Following are not intended for C               **
**      They are used internally to support above      **
**      They protect all non-return registers          **
**                                                     **
*********************************************************

*       int  conis(); return -1 if key active, else 0
conis
        move.l  a0,-(sp)
        move.w  #$0b,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        rts


*       wait for char, no echo  Return Z set if ^C
necin   move.l  a0,-(sp)
        move.w  #8,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        cmpi.b  #$03,d0
        rts

*       bconout(device, char)
*               display control char instead of executing them
bconout movem.l d0-d2/a0-a2,-(sp)
        move.w  d0,-(sp)
        move.w  #5,-(sp)
        move.w  #3,-(sp)
        trap    #13
        addq.l  #6,sp
        movem.l (sp)+,d0-d2/a0-a2
        rts

*       char out.  Preserve d0,a0 for internal calls
conout  movem.l d0/a0,-(sp)
        move.w  d0,-(sp)
        move.w  #2,-(sp)
        trap    #1
        addq.l  #4,sp
        movem.l (sp)+,d0/a0
        rts

*       conout 2 bytes packed in d0.w, left byte first
con2    move.w  d0,-(sp)
        lsr     #8,d0
        bsr     conout
        move.w  (sp)+,d0
        bra     conout

bkspc   move.w  #$08,d0
        bsr     conout
        move.w  #$2008,d0
        bra     con2


******  d0.w -> ascii string *a1, using strbuff work space
*               on entry: a1 -> strbuff + strlen
*                         d0 =  integer
*               on exit:  *strbuff = leading spaces + num
*                         *a1      = sign char of num in strbuff
bindec
        move.b  #' ',d2        default + sign
        tst.w   d0             0?
        bne.s   bindec1
        clr.b   -(a1)            yes..*a1 = " 0",null
        move.b  #'0',-(a1)
        move.b  #' ',-(a1)
        bra.s   bindec0
bindec1 bpl.s   bindec2        -?
        move.b  #'-',d2          yes..set '-' sign
        neg.w   d0                    abs(num)
bindec2 clr.b   (a1)           terminate string
        moveq   #4,d1          5 digits max
        andi.l  #$ffff,d0
bindec3 divu    #10,d0
        swap    d0             pick up remainder
        addi.b  #'0',d0
        move.b  d0,-(a1)
        swap    d0             pick up remnant of num/10
        andi.l  #$ffff,d0      clear d0 hi for divu
        dbeq    d1,bindec3     exit if done
bindec4 move.b  d2,-(a1)       insert sign bit
bindec0 rts


******  *a0 ascii string -> binary in d0.l
*
decbin  clr.l   d0              number
        clr.l   d1              new digit
        clr.b   d2              sign flag
        move.b  (a0)+,d1        1st char sign?
        cmpi.b  #'-',d1
        bne.s   decin1
        move.b  #$ff,d2           set minus flag
        bra.s   decin2
decin1  cmpi.b  #'+',d1
        bne.s   decin3
decin2  move.b  (a0)+,d1        pick up next char
decin3  tst.b   d1              end of string?
        beq.s   decin4            yes..exit
        subi.b  #$30,d1         digit? ascii to bcd
        bcs.s   decin4            less than '0'..exit
        cmpi.b  #10,d1
        bpl.s   decin4            gtr  than 10 ..exit
        mulu    #10,d0          10*(previous sum) -> d0
        add.l   d1,d0                             + new digit -> d0
        bvs.s   decin0
        bra.s   decin2          next char
decin4  tst.b   d2              minus?
        beq.s   decin0
        neg.l   d0
decin0  rts


******  call supervisor mode
gosuper clr.l   -(sp)
        move.w  #$20,-(sp)
        trap    #1
        addq.l  #6,sp
        move.l  d0,superst       save sys stack
        rts

******  return to user mode
gouser  move.l  sp,d2            save current return stack
        move.l  superst,-(sp)    restore spvsr stack (saved?? !!)
        move.w  #$20,-(sp)
        trap    #1
        move.l  d2,sp              current return, not the one that
        rts                        called gosuper.


pterm   move.w  #$0,-(sp)       dummy return message
        move.w  #$4c,-(sp)      closes files & cleans up
        trap    #1              bye, bye!

******************  .data  **************************************

        even
*       .data
anykey  dc.b    $0a,'...any key (Control-C to exit)....',0
        even     
timecue dc.b    $0a,'Enter time: ',0
        even
datecue dc.b    $0a,'Enter date: ',0

******************  .bss   **************************************
*        .bss
         even
superst  ds.l    1      supervisor stack
kbuff    ds.l    $100   keyboard buffer
head     ds.w    1
tail     ds.w    1
strbuff  ds.b    82     string i/o buffer
         .end


