*******************************************************************
*  cpmem        DRI C functions to copy memory from, to, #bytes
*               Pat Warnshuis (1-503-246-3724)
*               February 22, 1986
*
*               Handle memory overlap in either direction
*
*               cpmeml(from, to, long_cnt)   /*  LONG copy        */
*                      char *from, *to;
*                      long int cnt;         /*  NOTE LONG value! */
*
*
*               cpmemi(from, to, int_cnt)    /*  SHORT copy       */
*                      char *from, *to;
*                      int  cnt;             /*  NOTE INT value!  */
*

       .globl _cpmeml         for DRI C inteface
       .globl _cpmemi
       .text

_cpmemi move.w  12(sp),d0      integer byte count
        andi.l  #$ffff,d0        insure clean word for integer entry
        ext.l   d0               make compatible with long routine
        bra     cpmem1         rest of move is same as long move

_cpmeml move.l  12(sp),d0      long byte count
cpmem1  move.l  4(sp),a0       *from
        move.l  8(sp),a1       *to

        tst.l   d0             ck funny values
        beq.s   exit              no copy
        bmi.s   exit              what?!! You don't even rate a warning!!
        subq.l  #1,d0          decrement for 1st dbra
        cmpa.l  a0,a1          (from > to)?
        bcc.s   hilo               no....  work hi-lo

lohi    move.b  (a0)+,(a1)+    from>to.... work lo-hi
        dbra    d0,lohi        loop move 64k bytes
        swap    d0             move block counter to d0.w
        tst.w   d0             another block?
        beq.s   exit             no...all done
        subq.w  #1,d0          decrement block counter
        swap    d0             d0.w = #$ffff from last block
        bra     lohi           copy next block

hilo    add.l   d0,a0          from<to....work hi-lo
        add.l   d0,a1          move ptrs to end
        addq.l  #1,a0          adjust for 1st predecrement
        addq.l  #1,a1

hilo1   move.b  -(a0),-(a1)   64k loop
        dbra    d0,hilo1

        swap    d0            next block?
        tst.w   d0
        beq.s   exit
        subq.w  #1,d0
        swap    d0
        bra     hilo1      

exit    rts
        .end

