*******************************************************
*  cutil.s     68K asm routines to support DRI C
*              Pat Warnshuis (1-503-246-3724)
*              March 29, 1986
*
*

*******************************************************
*******************************************************
**                                                   **
**                                                   **
**  The following routines are written to be called  **
**  from DRI C.  They receive their arguments on the **
**  stack and use d0-d2/a0-a2                        **
**                                                   **
*******************************************************
*******************************************************


  .globl  _clrscrn
  .globl  _home
  .globl  _crsron
  .globl  _crsroff
  .globl  _revvid
  .globl  _norvid
  .globl  _savcrsr   os resets saveflag on many vt52 crsr cmds...
  .globl  _rescrsr      eeol, esol, crsrlt, rt, up, down, home, etc
  .globl  _eline
  .globl  _eeol
  .globl  _esoln
  .globl  _wrapon
  .globl  _wrapoff
  .globl  _crsrup
  .globl  _crsrdn
  .globl  _crsrrt
  .globl  _crsrlt
  .globl  _setfgd
  .globl  _setbkd

  .globl  _pstncrsr
  .globl  _crlf
  .globl  _crlf2

  .globl  _gouser   hidems, crsron, clrscrn, wrapon, kinit
  .globl  _gogem    showms, crsroff, pterm
  .globl  _hidems
  .globl  _showms

  .globl  _ckkbd    if(conis) kbuff[++tail] = char, else ckbuf
  .globl  _ckbuf    char = buff[++head], else -1 (process all buff)
  .globl  _cget     wait for char & echo it
  .globl  _cgetne   wait for char,  no echo
  .globl  _sput     put string with no auto crlf, '\n' ok
  .globl  _sget     get string with prompt & edit functions
  .globl  _sgetl    sget with max length
  .globl  _slen
  .globl  _scpy
  .globl  _sfinds   find string in string
  .globl  _sfindl   find string in line
  .globl  _sfindr   find string in record
  .globl  _cfinds   find char   in string
  .globl  _cfindl   find char   in line (from start)
  .globl  _cfindr   find char   in record
  .globl  _iget     get int  to string
  .globl  _igetl    get long to string
  .globl  _iout2    put 0<int<100
  .globl  _iput     put -32767<int<+32767 no leading zeroes
  .globl  _iputj    put -32767<int<+32767 right justified in strlen
  .globl  _bindec   int to ascii string, no leading zeroes
  .globl  _bindecj  int to ascii string, right justified
  .globl  _gtime    get time to string HH:MM:SS
  .globl  _gdate    get date to string MO/DA/YEAR
  .globl  _stime    set time
  .globl  _sdate    set date
  .globl  _cpmemi   copy mem from, to, #bytes<64k
  .globl  _cpmeml   copy mem from, to, #bytes>64k
  .globl  _wait     '...any key..." & wait for necin

  .text

*       VOID gouser();         graceful entry
_gouser bsr     _hidems        should save mouse state for exit
        bsr     _crsron        ditto
        bsr     _clrscrn
        bsr     _wrapon
        bsr     _kinit
        rts

_gogem  bsr     _crsroff       graceful exit should restore crsr
        bsr     _showms        ditto
        bra     pterm          deallocate mem, restore stack & go cmd

_kinit  clr.w   head
        clr.w   tail
        rts

******  long int ckkbd(); if(conis) kbuff[tail++]=conin()
*                         else fall thru to _ckbuf
*       if(conis)
*          conin();
*          if( tail++ == 64 ) tail = 0;
*          if( tail <> head ) kbuff[tail] = ch
*              else dump ch and fall thru to _ckbuf

_ckkbd  movem.l d1/a0,-(sp)    protect a0 in case we are filling a buffer
        bsr     conis          key active?
        beq.s   ckbuf1           no...ck kbuff
        bsr     necin            yes..get ch from keyboard
        move.w  tail,d1
        addq    #4,d1              tail++
        cmpi.w  #$100,d1             wrap tail?
        bne     ckkbd1                 no
        moveq   #0,d1                  yes..tail=0
ckkbd1  move.w  d1,tail              save new tail
        cmp.w   head,d1            caught up with head?
        beq.s   ckbuf2               yes...dump ch & get_kbuff[++h]
        lea     kbuff,a0             no....move key to buff
        move.l  d0,0(a0,d1.w)              kbuff[++t]=ch
        bra.s   ckbuf1         go ck buff

******  long int ckbuf(); if(kbuff[head]) ch=kbuff[head++], else ch=(-1)
*       if( head <> tail)
*          ch = kbuff[++h];
*          if( head == 80) head=0
*       else char = -1;
*

_ckbuf  movem.l d1/a0,-(sp)
ckbuf1  move.w  head,d1
        cmp.w   tail,d1        head==tail (empty)
        beq.s   ckbuf4           yes..return -1
ckbuf2  addq    #4,d1          head++
        cmpi.w  #$100,d1         wrap head?
        bne.s   ckbuf3             no
        moveq   #0,d1              yes..head=0
ckbuf3  move.w  d1,head        save head
        lea     kbuff,a0       ch=kbuff[++h]
        move.l  0(a0,d1.w),d0
        bra.s   ckbuf0
ckbuf4  moveq   #-1,d0         buff empty and no kbd
ckbuf0  movem.l (sp)+,d1/a0
        rts


******  char cget(); get kbuff[h] or wait for kbdin
*                    echo ch to screen

_cget   bsr     _ckkbd
        bmi.s   _cget
        bsr     conout         echo input
        rts
******  char cgetne(); same as cget() with no echo
*

_cgetne bsr     _ckkbd
        bmi.s   _cget
        rts


******  sput(s) char *s;       print string with no auto crlf
*                              display control characters
*                              send crlf for '\n'

_sput   move.l  4(sp),a0
sput    move.l  a0,-(sp)
sput1   move.b  (a0)+,d0
        beq.s   sput0
        cmpi.b  #$0a,d0        '\n' ?
        bne.s   sput2               no
        bsr     _crlf                yes
        bra.s   sput1
sput2   bsr     bconout
        bra.s   sput1
sput0   move.l  (sp)+,a0
        rts

******  integer *sget(prompt, response) char *prompt, response;
*               returns char cnt or -(spec char), if entered
*
*       sget    gets a string from console with edit functions
*               displays prompt (a0), and default response (a1)
*               immediate <return> returns default str & cnt=0
*               immediate ESC  restarts string
*                   to enter <esc> at start, enter it twice
*               immediate BS edits existing response string
*               any other char starts new response string
*               BS  at any char backspaces until 1st char
*               response is terminated by <return>
*               normal return is char cnt in d0
*                             a0 points to response (internal use)
*               any control char returns -(control char)
*               any spec key returns -(scan code)

****   integer  *sgetl(prompt, response, length)
*               same as sget() with max string length included

_sgetl  move.w  12(sp),d2      max string length
        bra.s   sgeta


_sget   move.w  #80,d2
sgeta   move.l  4(sp),a0       caller's prompt   string
        move.l  8(sp),a1       caller's response string
*                              internal call with a0=prompt, a1=response
sget
        move.l  a1,-(sp)       save -> start of response
        moveq   #$0,d1         strlen=0
        bsr     _eeol
        bsr     sput           display prompt
        bsr     _savcrsr
        tst.b   (a1)           default str?
        beq.s   sget3            no...start input
        move.l  (sp),a0          yes..display default
        bsr     sput
        bsr     slen                  get len of default response
        move.w  d0,d1
        add.w   d1,a1                 ptr to default end

sget1   bsr     _cgetne        1st char
        cmpi.b  #$0d,d0        CR?
        bne.s   sget1a
        moveq   #$0,d1           yes...rtn default str & cnt=0
        bra     sget9
sget1a  cmpi.b  #$08,d0        BS?
        beq.s   sget6            yes...do not erase str
        tst.w   d1               no ...erase str
        beq.s   sget2                  no str to erase
        move.w  d0,-(sp)               save 1st char
        bsr     _rescrsr               erase default response
        bsr     _eeol
        bsr     _savcrsr
        moveq   #0,d1                  reset cnt
        move.w  (sp)+,d0               retrieve char
        move.l  (sp),a1                ptr to default start

sget2
        cmpi.b  #$08,d0        BS?
        beq.s   sget6             yes...backup ptr
        cmpi.b  #$0d,d0        CR?
        beq.s   sget9             yes...wrap it up
        cmp.b   d1,d2          max cnt?
        beq.s   sget8             yes...ring de bell & ignore it
        tst.w   d0             special keys help, undo, function, etc?
        beq.s   sget4             yes...return -(scan code)
        bsr     bconout        echo char
        addq.b  #1,d1          bump char cnt
        move.b  d0,(a1)+       add char to str
sget3   bsr     _cgetne        get next char
        bra.s   sget2             and process it
      
sget4   swap    d0             special char..get scan code to d0.w
        cmp.b   #'G',d0        CLR/HOME?
        bne.s   sget5            no...return -(scancode)
        bsr     _rescrsr         yes..start over
        bsr     _eeol
        bsr     _savcrsr
        moveq   #0,d1
        move.l  (sp),a1
        bra.s   sget1
sget5   move.l  (sp),a1        return reply[0]  = scancode
        move.b  d0,(a1)+
        clr.b   (a1)
        neg.w   d0                    and count = -(scancode)
        bra.s   sget0
sget6   tst.b   d1             BS..at start?
        beq.s   sget1              yes..ignore it
        subq.b  #1,d1              no...adjust cnt
        clr.b   -(a1)                   delete last char
        bsr     bkspc                   backup cursor
        bra.s   sget3                   go get next
sget8   move.w  #$07,d0        Overflow!
        bsr     conout             sound bell
        bra.s   sget3              ignore char

sget9   clr.b   (a1)           terminate string
        move.w  d1,d0          done.  cnt -> d0
sget0   move.l  (sp)+,a0       return a0 ->  start of response string
        rts                           d0.w = char cnt or -(spec char)

******* integer slen(s) char *s;
_slen   move.l  4(sp),a0
slen    move.l  a0,-(sp)        stash ptr
        moveq   #-1,d0          char cnt
slen1   addq    #1,d0
        tst.b   (a0)+
        bne.s   slen1
slen0   move.l  (sp)+,a0        restore ptr
        rts

******  VOID scpy(to,from) char *to, *from;
*                 "to = from"
_scpy   move.l  8(sp),a1        from
        move.l  4(sp),a0        to
*                               internal entry
scpy    move.l  a0,-(sp)        save *dest
scpy1   move.b  (a1)+,(a0)+     cpy str from a1 to a0
        bne.s   scpy1
        move.l  (sp)+,a0        reset *dest
        rts                                                

******  find string in text:
*       long sfinds(str1, str2)   find str1 in str2
*       lond sfindl(string, text) find string in line
*       long sfindx(string, text) find string in record
*
*       returns offse t of string from start of text

_sfinds move.b  #$0,d1         set string search terminator
        bra     sfind

_sfindl move.b  #$0a,d1        set line search terminator
        bra     sfind

_sfindr move.w  12(sp),d1      set caller's record terminator
        bra     sfind



******  find character in text:
*       long cfinds(char, string) find char in string
*       long cfindl(char, line)   find char in line
*       long cfindr(char, record) find char in record
*
*       return offset of char from start of text

_cfinds move.b  #$00,d1        string stop_char
        bra     cfind

_cfindl move.b  #$0a,d1        line stop_char
        bra     cfind

_cfindr move.w  12(sp),d1      caller's record terminator
        bra     cfind


*****  long integer igetl(s) char *s;   prompt string
*           integer iget(s)  char *s:   use for any type.  no error ck
*      convert decimal number from keyboard to binary long in d0
*      stop on any non-decimal character.

_igetl  move.w  #$0a,d2
        bra.s   iget1

_iget   moveq   #6,d2           max char cnt

iget1   move.l  4(sp),a0        prompt string
        lea     strbuff,a1      input buffer
        clr.b   (a1)            default str = null
        bsr     sget            get ascii decimal into a0
        bsr     decbin          *a0 str -> d0.l bin
        rts



******  VOID out2(num) integer num;  0<num<100 !!
*       send 2-digit num (0-99) in d0.b to console (because it's easy!)

_iout2  move.w  4(sp),d0
iout2   andi.l  #$ff,d0        mask garbage for divs
        divs    #10,d0         tens->d0.lo, ones->d0.hi
        add.l   #$300030,d0     convert both to ascii
        bsr     conout
        swap    d0              get ones
        bra     conout


******  VOID  iput(num) integer num;
*                  display num.  Suppress leading zeroes, strlen=len(num)

_iput   move.w  4(sp),d0       num
        lea     strbuff,a0     fake user string
        bsr     bndec1         d0.w -> *a0, no leading zeroes
        bsr     conws                       strlen=len(num)
        rts

******  VOID bindec(num, string) int num; char *string;
*                   convert integer to dec in string
*                   suppress leading zeroes, strlen=len(num)

_bindec move.w  4(sp),d0       num
        move.l  6(sp),a0       user_string
bndec1
        lea     strbuff,a1
        addq.l  #6,a1          max strlen (include sign)
        bsr     bindec         num -> *a1, no leading zeroes
        bsr     scpy           *a0  = *a1
        rts                    *str = bindec(num)


******  VOID iputj(num, strlen) int num, strlen;
*                  display num right justified by strlen

_iputj  move.w  4(sp),d0       num
        move.w  6(sp),d1       strlen
        lea     strbuff,a0     fake user string
        bsr     bndecj1        d0.w -> *a0, rt just by strlen
        bsr     conws
        rts

*****   VOID bindecj(num, str, strlen)
*                    int or unsigned num, strlen; char *str
*                    num -> str, rt justified by strlen

_bindecj
        move.w  4(sp),d0       num
        move.l  6(sp),a0       user_str
        move.w  10(sp),d1      strlen

bndecj1 lea     strbuff,a1     fill strbuff with spaces
        subq    #1,d1
bndecj2 move.b  #' ',(a1)+
        dbra    d1,bndecj2     leave a1 at end of str
        bsr     bindec         num -> *a1 in strbuff
        lea     strbuff,a1     pick up leading spaces
        bsr     scpy           str=bindecj(num), rt justified by strlen
        rts

******  void gtime(str) char *str; string to receive time
*       enter time from key and convert to ascii in a0

_gtime  move.l  4(sp),a0       caller's string pointer
        bra.s   gtime1

*       use this entry for internal calls (use strbuff)
gtime   lea     strbuff,a0

gtime1  move.l  a0,-(sp)       park *str
        move.w  #23,-(sp)      gettime in d0.l
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,a0       retrieve *str

        andi.l  #$ffff,d0
        move.w  d0,-(sp)       temp storage
        lsr.w   #8,d0          hr
        lsr.w   #3,d0
        andi.w  #$1f,d0
        bsr.s   set2
        move.b  #':',(a0)+
        move.w  (sp),d0        min
        lsr.w   #5,d0
        andi.w  #$3f,d0
        bsr.s   set2
        move.b  #':',(a0)+
        move.w  (sp)+,d0       sec
        andi.w  #$1f,d0
        lsl.w   #1,d0
        bsr.s   set2
        clr.b   (a0)
        rts

******  Convert bin byte in d0 to ascii dec (0-99) in *a0
*       Support gtime and gdate routines
set2
        andi.l  #$ff,d0         clear hi word for divu
        divu    #10,d0          10's digit d0.lo, 1's digit d0.hi
        addi.l  #$300030,d0     convert bcd to ascii
        move.b  d0,(a0)+
        swap    d0
        move.b  d0,(a0)+
        rts

******  void gdate(s) char *s;  string to receive date
*       enter date from key & convert to ascii in caller's string

_gdate  move.l  4(sp),a0
        bra.s   gdate1

*       use this entry for internal calls (use strbuff)
gdate   lea     strbuff,a0

gdate1  move.l  a0,-(sp)
        move.w  #23,-(sp)       get date/time in d0.l
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,a0
        swap    d0              move date to d0.w
        andi.l  #$ffff,d0
        move.w  d0,-(sp)        store the packed dates (ha,ha,ha!)
        lsr.w   #5,d0           mo
        andi.w  #$0f,d0
        bsr.s   set2
        move.b  #'/',(a0)+
        move.w  (sp),d0         day
        andi.w  #$1f,d0
        bsr.s   set2
        move.b  #'/',(a0)+
        move.w  (sp)+,d0        yr
        lsr.w   #8,d0
        lsr.w   #1,d0
        add.b   #80,d0
        andi.w  #$7f,d0
        bsr.s   set2
        clr.b   (a0)
        rts 

******  VOID stime()
*       get time from keyboard and set system clock
_stime
        lea     strbuff,a0
        bsr     gtime          get time to ascii str in strbuff
        lea     strbuff,a1        display default time
        lea     timecue,a0        prompt
        move.w  #8,d2
        bsr     sget            get new time
        bsr     decbin          pack ascii time at a0 into d0.w
        lsl.w   #8,d0           decbin: 2 ascii digits at a0 -> bin in d0.w
        lsl.w   #3,d0           pack hr
        move.w  d0,-(sp)
        bsr     decbin          pack min
        lsl.w   #5,d0
        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)
        bsr     decbin          pack sec
        lsr.w   #1,d0   
        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)        park new time
        move.w  #23,-(sp)       get current date/time
        trap    #14
        addq.l  #2,sp
        move.w  (sp)+,d0        pack date/time
        move.l  d0,-(sp)        set hardware clock, xbios
        move.w  #22,-(sp)
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,d0        set sw clock, bios
        andi.l  #$ffff,d0
        move.w  d0,-(sp)
        move.w  #$2d,-(sp)
        trap    #1
        addq.l  #4,sp
        rts     


******* VOID set_date()
*       get date from keyboard and set system date
_sdate
        lea     strbuff,a0
        bsr     gdate           get date to ascii str in strbuff
        lea     strbuff,a1      default response
        lea     datecue,a0      prompt
        move.w  #10,d2
        bsr     sget            get new time in strbuff, *a0


        bsr     decbin          2 ascii at *a0 to binary in d0.w
        lsl.w   #5,d0           pack mo
        move.w  d0,-(sp)
        bsr     decbin          pack day
        move.w  (sp),d1
        or.w    d1,d0
        move.w  d0,(sp)
        bsr     decbin          pack yr
        cmpi.w  #1900,d0             2-digit or 4-digit?
        bmi.s   sdate1
        subi.w  #1900,d0
sdate1  subi.w #80,d0                less 80 for TOS format
        lsl.w   #8,d0
        lsl.w   #1,d0   
        move.w  (sp)+,d1
        or.w    d1,d0
        move.w  d0,-(sp)        park new date
        move.w  #23,-(sp)       get current date/time
        trap    #14
        addq.l  #2,sp
        swap    d0              current time to d0.hi
        move.w  (sp)+,d0        new date to d0.lo
        swap    d0              pack date/time in d0.l
        move.l  d0,-(sp)        set hardware date/time, xbios
        move.w  #22,-(sp)
        trap    #14
        addq.l  #2,sp
        move.l  (sp)+,d0        set sw date, bios
        swap    d0
        andi.l  #$ffff,d0
        move.w  d0,-(sp)
        move.w  #$2b,-(sp)
        trap    #1
        addq.l  #4,sp
        rts     

*******************************************************************
*  cpmem        copy memory from, to, #bytes                      *
*               February 22, 1986                                 *
*                                                                 *
*               Handle memory overlap in either direction         *
*                                                                 *
*  VOID cpmeml(from, to, long_cnt)       LONG copy >32k           *
*                      char *from, *to;                           *
*                      long int cnt;     NOTE LONG value!         *
*                                                                 *
*                                                                 *
*  VOID cpmemi(from, to, int_cnt)        SHORT copy <32k          *
*                      char *from, *to;                           *
*                      int  cnt;         NOTE INT value!          *
*                                                                 *
*******************************************************************

_cpmemi move.w  12(sp),d0      integer byte count
        andi.l  #$ffff,d0        insure clean word for integer entry
        ext.l   d0               make compatible with long routine
        bra     cpmem1         rest of move is same as long move

_cpmeml move.l  12(sp),d0      long byte count
cpmem1  move.l  4(sp),a0       *from
        move.l  8(sp),a1       *to

        tst.l   d0             ck funny values
        beq.s   cpmem0              no copy
        subq.l  #1,d0          decrement for 1st dbra
        cmpa.l  a0,a1          (from > to)?
        bcc.s   hilo               no....  work hi-lo

lohi    move.b  (a0)+,(a1)+    from>to.... work lo-hi
        dbra    d0,lohi        loop move 64k bytes
        swap    d0             move block counter to d0.w
        tst.w   d0             another block?
        beq.s   cpmem0             no...all done
        subq.w  #1,d0          decrement block counter
        swap    d0             d0.w = #$ffff from last block
        bra     lohi           copy next block

hilo    add.l   d0,a0          from<to....work hi-lo
        add.l   d0,a1          move ptrs to end
        addq.l  #1,a0          adjust for 1st predecrement
        addq.l  #1,a1

hilo1   move.b  -(a0),-(a1)   64k loop
        dbra    d0,hilo1

        swap    d0            next block?
        tst.w   d0
        beq.s   cpmem0
        subq.w  #1,d0
        swap    d0
        bra     hilo1      

cpmem0    rts

_hidems dc.w    $a00a           a-line cmd
        rts
_showms dc.w    $a009
        rts

*****   VOID wait();  issue prompt and wait for anykey
*                     exit program on ^C

_wait   lea   anykey,a0
        bsr   conws
        bsr   necin
        beq   _gogem
        rts

**************************************************
*                                                *
*       VT52 functions                           *
*                                                *
**************************************************

******  VOID pstncrsr(line,col) integer line, col;

_pstncrsr
        move.w  #$1b59,d0      send esc Y
        bsr     con2
        move.w  4(sp),d0       pack line, col in d0.w for con2
        lsl.w   #8,d0
        or.w    6(sp),d0
        add.w   #$2020,d0
        bra     con2

_setfgd move.w  #$1b62,d0       Select color register for foreground
        bsr     con2            For mono, 0=white, 1=black
        move.w  4(sp),d0
        bra     conout

_setbkd move.w  #$1b63,d0
        bsr     con2
        move.l  4(sp),d0
        bra     conout

_crlf   move.w  #$0d0a,d0
        bra     con2
_crlf2  bsr     _crlf
        bra     _crlf

_clrscrn move.w  #$1b45,d0
        bra     con2
_home   move.w  #$1b48,d0
        bra     con2
_crsron move.w  #$1b65,d0
        bra     con2
_crsroff move.w  #$1b66,d0
        bra     con2
_revvid move.w  #$1b70,d0
        bra     con2
_norvid move.w  #$1b71,d0
        bra     con2
_savcrsr move.w  #$1b6a,d0
        bra     con2
_rescrsr move.w  #$1b6b,d0
        bra     con2
_eline  move.w  #$1b6c,d0
        bra     con2
_eeol   move.w  #$1b4b,d0
        bra     con2
_esoln  move.w  #$1b6f,d0
        bra     con2
_wrapon move.w  #$1b76,d0
        bra     con2
_wrapoff move.w #$1b77,d0
        bra     con2
_crsrup move.w  #$1b41,d0
        bra     con2
_crsrdn move.w  #$1b42,d0
        bra     con2
_crsrrt move.w  #$1b43,d0
        bra     con2
_crsrlt move.w  #$1b44,d0
        bra     con2


*********************************************************
**                                                     **
**                                                     **
**      Following are not intended for C               **
**      They are used internally to support above      **
**      They protect all non-return registers          **
**                                                     **
*********************************************************

*       int  conis(); return -1 if key active, else 0
conis
        move.l  a0,-(sp)
        move.w  #$0b,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        rts

*       char conin();
*       wait for char, echo.    Return Z set if ^C

conin   move.l  a0,-(sp)
        move.w  #1,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        cmpi.b  #$03,d0
        rts

*       wait for char, no echo  Return Z set if ^C
necin   move.l  a0,-(sp)
        move.w  #8,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        cmpi.b  #$03,d0
        rts

*       bconout(device, char)
*               display control char instead of executing them
bconout movem.l d0-d2/a0-a2,-(sp)
        move.w  d0,-(sp)
        move.w  #5,-(sp)
        move.w  #3,-(sp)
        trap    #13
        addq.l  #6,sp
        movem.l (sp)+,d0-d2/a0-a2
        rts

*       char out.  Preserve d0,a0 for internal calls
conout  movem.l d0/a0,-(sp)
        move.w  d0,-(sp)
        move.w  #2,-(sp)
        trap    #1
        addq.l  #4,sp
        movem.l (sp)+,d0/a0
        rts

*       conout 2 bytes packed in d0.w, left byte first
con2    move.w  d0,-(sp)
        lsr     #8,d0
        bsr     conout
        move.w  (sp)+,d0
        bra     conout

*       *a0 string to console.  Protect a0
conws   move.l  a0,-(sp)
        move.w  #9,-(sp)
        trap    #1
        addq.l  #2,sp
        move.l  (sp)+,a0
        rts

space   move.w  #$20,d0
        bra     conout

bkspc   move.w  #$08,d0
        bsr     conout
        move.w  #$2008,d0
        bra     con2


******  *a0 ascii string -> binary in d0.l
*
decbin  clr.l   d0              number
        clr.l   d1              new digit
        clr.b   d2              sign flag
        move.b  (a0)+,d1        1st char sign?
        cmpi.b  #'-',d1
        bne.s   decin1
        move.b  #$ff,d2           set minus flag
        bra.s   decin2
decin1  cmpi.b  #'+',d1
        bne.s   decin3
decin2  move.b  (a0)+,d1        pick up next char
decin3  tst.b   d1              end of string?
        beq.s   decin4            yes..exit
        subi.b  #$30,d1         digit? ascii to bcd
        bcs.s   decin4            less than '0'..exit
        cmpi.b  #10,d1
        bpl.s   decin4            gtr  than 10 ..exit
        mulu    #10,d0          10*(previous sum) -> d0
        add.l   d1,d0                             + new digit -> d0
        bvs.s   decin0
        bra.s   decin2          next char
decin4  tst.b   d2              minus?
        beq.s   decin0
        neg.l   d0
decin0  rts



******  d0.w -> ascii string *a1, using strbuff work space
*               on entry: a1 -> strbuff + strlen
*                         d0 =  integer
*               on exit:  *strbuff = leading spaces + num
*                         *a1      = sign char of num in strbuff
bindec
        move.b  #' ',d2        default + sign
        tst.w   d0             0?
        bne.s   bindec1
        clr.b   -(a1)            yes..*a1 = " 0",null
        move.b  #'0',-(a1)
        move.b  #' ',-(a1)
        bra.s   bindec0
bindec1 bpl.s   bindec2        -?
        move.b  #'-',d2          yes..set '-' sign
        neg.w   d0                    abs(num)
bindec2 clr.b   (a1)           terminate string
        moveq   #4,d1          5 digits max
        andi.l  #$ffff,d0
bindec3 divu    #10,d0
        swap    d0             pick up remainder
        addi.b  #'0',d0
        move.b  d0,-(a1)
        swap    d0             pick up remnant of num/10
        andi.l  #$ffff,d0      clear d0 hi for divu
        dbeq    d1,bindec3     exit if done
bindec4 move.b  d2,-(a1)       insert sign bit
bindec0 rts


***************************************************
*       integer sfind(string, text) *string, *text
*               called by _sfinds, _sfindl, _sfindx
*
*       for string search, d1 = 0
*       for line search,   d1 = '\n'
*       for record search, d1 = 12(sp), terminator from caller
*
*       exits on hit or stop_char
*       returns offset of string from start of text or -1

*      pop        registers:   constant   variable
sfind
       move.l   4(sp),a1                 a1 = txtptr
       move.l   8(sp),a0       a0=2NDCH  a2=sptr after 1st char
*                              d1=EOT    a3=txtptr after 1st char
       bsr      slen           d2=*1STCH d4=char cnt
*                              d3=SOT
       movem.l  d3-d4/a3,-(sp)
       subq.l   #2,d0          dbra loop cntr starts on 2nd char
       move.b   (a0)+,d2       1st char in s
       move.l   a1,d3          d3=start of text
fnd1st cmp.b    (a1),d1        eot?
       beq.s    fndno            yes..return -1
       cmp.b    (a1)+,d2       1st char?
       bne.s    fnd1st           no..keep looking

       move.l   d0,d4            yes..str len
       move.l   a0,a2                 -> 2nd char of str
       move.l   a1,a3                 -> text
fndall cmp.b    (a3),d1        eot?
       beq.s    fndno            yes..return -1
       cmpm.b   (a3)+,(a2)+      next char match?
       bne.s    fnd1st           no..continue after last hit
       dbra     d4,fndall        yes..ck next
fndok  move.l   a1,d0          (start of hit)+1
       subq.l   #1,d0          start of s in text
       sub.l    d3,d0          offset of s from SOT
       bra.s    sfind0
fndno  move.w   #-1,d0
sfind0 movem.l  (sp)+,d3-d4/a3
       rts


****************************************************
*
*  integer *cfind(start, char) char *start, char, stop_char;
*          returns offset of char from start or -1
*

cfind   move.l  4(sp),a0       a0 = text_ptr
        move.w  8(sp),d0       d0 = target_char
*                              d1 = stop_char

cfind1  cmp.b   (a0),d0        tartet_char?
        beq.s   cfind2           yes..exit TRUE, and char *ptr
        cmp.b   (a0)+,d1       stop_char?
        bne.s   cfind1          no...keep looking

        clr.l   d0             miss...set FALSE flag
        bra.s   cfind0

cfind2  move.l  a0,d0          hit ...return char_ptr
        subq.l  #1,d0

cfind0  rts




pterm   move.w  #$0,-(sp)       dummy return message
        move.w  #$4c,-(sp)      closes files & cleans up
        trap    #1              bye, bye!

******************  .data  **************************************

        even
*       .data
anykey  dc.b    $0a,'...any key (Control-C to exit)....',0
        even     
timecue dc.b    $0a,'Enter time: ',0
        even
datecue dc.b    $0a,'Enter date: ',0

******************  .bss   **************************************
*        .bss
         even
kbuff    ds.l    $100   keyboard buffer
head     ds.w    1
tail     ds.w    1
strbuff  ds.b    82     string i/o buffer
         .end


