  .globl  _hi25   25 lines/screen
  .globl  _hi50   50 lines/screen
*****************************************************
*  create -hi25 and _hi50 globals for dri C language
*  _hi50 changes char font to  8x8  for small print
*  _hi25 changes char font to 16x16 for normal print
*  both routine use the A-line document procedures
*       
* author:  j. d. eisenstein
* date:    15-aug-85
*
* 02/01/86  assemble as globals for C by pat warnshuis 503-246-3724
*           return minus on error (not hires monitor)
*
* int hi25() returns minus if no hires monitor
* int hi50()

_hi25:

*       Since there are no local variables, we do not need to link/unlk
*       d0-d2/a0-a2 are scratch registers and do not need protection

        move.w  #$04,-(sp)         ; get screen resolution
        trap    #14                ; uses d0-d2/a0-a2
        addq.w  #2,sp
        cmp.w   #2,d0              ; only execute if in hi rez
        bne     nono

        dc.w    $a000              ; set a-line
        move.l  08(a1),a1          ; a1 -> 8x16 font header
        move.l  72(a1),-$0A(a0)    ; v_off_ad <- 8x16 offset table addr
        move.l  76(a1),-$16(a0)    ; v_fnt_ad <- 8x16 font data addr
        move.w  #0016,-$2E(a0)     ; v_cel_ht <- 16    8x16 cell height
        move.w  #0024,-$2A(a0)     ; v_cel_my <- 24    maximum cell "Y"
        move.w  #1280,-$28(a0)     ; v_cel_wr <- 16x80 vertical byte offset
        rts

_hi50:
        move.w  #$04,-(sp)              ; get screen resolution
        trap    #14
        addq.w  #2,sp
        cmp.w   #2,d0                   ; only execute if in hi rez
        bne     nono

        dc.w    $A000                   ; get the important pointers
        move.l  04(a1),a1               ; a1 -> 8x8 font header
        move.l  72(a1),-$0A(a0)         ; v_off_ad <- 8x8 offset table addr
        move.l  76(a1),-$16(a0)         ; v_fnt_ad <- 8x8 font data addr
        move.w  #008,-$2E(a0)           ; v_cel_ht <- 8    8x8 cell height
        move.w  #049,-$2A(a0)           ; v_cel_my <- 49   maximum cell "Y"
        move.w  #640,-$28(a0)           ; v_cel_wr <- 8x80 offset to cell Y+1
        bra.s   hi0
nono    moveq   #-1,d0                  ; error return
hi0     rts

  .globl  _hi25     scrn res
  .globl  _hi50
